<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc2119 SYSTEM "http://xml2rfc.tools.ietf.org/public/rfc/bibxml/reference.RFC.2119.xml">
<!ENTITY rfc5234 SYSTEM "http://xml2rfc.tools.ietf.org/public/rfc/bibxml/reference.RFC.5234.xml">
<!ENTITY rfc1123 SYSTEM "http://xml2rfc.tools.ietf.org/public/rfc/bibxml/reference.RFC.1123.xml">
// local reference to another doc
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>

// categories: std | bcp | info | exp | historic
rfc(category='std' number='2417673' consensus='false' ipr='trust200902' docName='dim-protocol-01' submissionType='be-cem-mro' xml:lang='en' version='3')
  front
    title(abbrev="DIM protocol") Distributed Information Management protocol
    author(fullname='Sylvain Fargier' initials='S.F.' role='editor' surname='Fargier')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email sylvain.fargier@cern.ch
    date(year='2019' month="May" day="16")

    keyword DIM

    abstract
      t
        | This document describes the DIM protocol, it has been written by
        | reverse engineering current library implementation and #[bcp14 MAY]
        | thus be inaccurate.

  middle
    section
      name Introduction
      t
        | #[xref(target="DIM_WEBSITE") DIM] is a communication system for
        | distributed/mixed environments, it provides a network transparent
        | inter-process communication layer.

      // This one is a 'must' :)
      section
        name Requirements Notation
        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119') RFC2119].

    section(anchor="Overview")
      name General Overview

      t This figure shows how DIM components interact:
      figure
        name DIM General Overview
        artwork(align='center' type='ascii-art')
          .
            <![CDATA[
            +------------+     Subscribe     +----------------------+
            |            +------------------->                      |
            | DIM Client |                   | DIM Service Provider |
            |            <-------------------+                      |
            +----+--^----+      Publish      +---------+------------+
                 |  |                                  |
                 |  |                                  |
                 |  | DNS Reply       DNS Registration |
                 |  |                                  |
                 |  |        +-----------------+       |
                 |  +--------+                 |       |
                 |           | DIM Name Server <-------+
                 +----------->                 |
                 DNS Query   +-----------------+
            ]]>

      t Those components can be referred to as #[tt DIM Nodes].

    section
      name Protocol

      t
        | On the contrary of most network protocols,
        | DIM headers are always encoded in little-endian.

      t
        | The fields and packets described in this section are named according
        | to the reference implementation.

      section
        name DIM Network Access (DNA)

        t
          | DIM Network Access implements the network layer of DIM.

        t
          | Each packet sent by a DIM Node #[bcp14 MUST] be preceded by
          | a DNA Header packet.

        figure
          name DNA Header
          artwork(align='center' type='ascii-art' name='' alt='')
            | <![CDATA[
            |  0                   1                   2                   3
            |  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
            | +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
            | |                         Header Size=12                        |
            | +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
            | |                           Data Size                           |
            | +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
            | |                          Header Magic                         |
            | +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
            | ]]>

        t
          | The #[tt Data Size] is the size in bytes of the payload packet
          | following this header.

        t
          | The #[tt Header Magic] is a magic number that indicates the payload
          | packet type, it can be one of:

        table(align='center')
          name DNA Packet Types
          thead
            tr
              th Code
              th Type
              th Description
          tbody
            tr
              td 0xFEADFEAD
              td DIM packet
              td Payload is a general DIM packet
            tr
              td 0x11131517
              td Test packet
              td Test packet with no payload

        section
          name DNA Test packets

          t
            | The DNA Test packet is a special DNA Header packet that has no
            | payload and is used in some DIM Nodes to keep socket alive.

          t
            | It #[bcp14 SHOULD] be sent by DIM Name Service on the sockets
            | and DIM Client nodes, DIM Service Providers #[bcp14 SHOULD NOT]
            | send such messages.

          t
            | On hosts where TCP_KEEPALIVE feature is supported (Linux/Unix),
            | this method #[bcp14 SHOULD] be preferred and configured with
            | the following values: TCP_KEEPIDLE=15, TCP_KEEPINTVL=3,
            | TCP_KEEPINTVL=5.

          t
            | On other hosts those DNA Test packets #[bcp14 SHOULD] be sent
            | after 15 seconds of inactivity.

      section
        name DIM Network Access Open

        t
          | DNA Open packets is the first packet that #[bcp14 MUST] be sent by
          | a client node when connecting to a server.

        figure
          name DNA Open Header
          artwork(align='center' type='ascii-art' name='' alt='')
            .
              <![CDATA[
               0                   1                   2                   3
               0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
              +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
              |                        Code=0xC0DEC0DE                        |
              +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
              |                                                               |
              +                           Node Name                           +
                                             ...
              +                           (40 bytes)                          +
              |                                                               |
              +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
              |                                                               |
              +                              Task                             +
                                             ...
              +                           (40 bytes)                          +
              |                                                               |
              +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
              ]]>

        t
          | The #[tt Node Name] and #[tt Task] field contains information as
          | described in #[xref(target="Node_Names")].

        t
          | #[strong Note:] Due to some DIM Name Service restrictions,
          | the #[tt Task] field #[bcp14 SHOULD] be limited to 36 bytes.

        t
          | #[strong Note:] there can be several DIM Nodes on the same machine
          | and thus sharing the same #[tt Node Name].

      section(anchor="DNS")
        name DIM Name Service (DNS)

        t
          | The DIM Name Service protocol is used to register and query services,
          | it is implemented on a DIM Name Server that handle requests.

        t
          | DIM Name Servers #[bcp14 MUST] listen for incoming requests on TCP
          | port #[tt 2505].

        t
          | All packets that are sent to a DIM Name Server #[bcp14 MUST] use
          | the same base header.

        figure
          name DIM Name Service request header
          artwork(align='center' type='ascii-art' name='' alt='')
            .
              <![CDATA[
               0                   1                   2                   3
               0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
              +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
              |                              Size                             |
              +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
              |                              Type                             |
              +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
              |                                                               |
              +                            Payload                            +
                                             ...
              +                        (Size - 8 bytes)                       +
              |                                                               |
              +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
              ]]>

        t The payload contents depends on the #[tt Type] field.

        t
          | #[strong Note:] The #[tt Size] field is redundant with
          | #[tt Data Size] field from the DNA Header, it contains the same
          | value.

        t The #[tt Type] field can be one of:
        table(align='center')
          name DIM Name Service Request Types
          thead
            tr #[th Code] #[th Type]
          tbody
            tr
              td 1
              td #[xref(target="DNS_Registration") DIM Name Service Registration]
            tr
              td 2
              td #[xref(target="DNS_Query") DIM Name Service Query]

        t Any other value #[bcp14 MUST] be ignored by the DIM Name Server.

        t
          | A DIM Name Server #[bcp14 MAY] send
          | #[xref(target="DNS_Command") DIM Name Service Command packets] once
          | it has received at least one
          | #[xref(target="DNS_Registration") DIM Name Service Registration] packet.

        t
          | A DIM Name Server #[bcp14 MAY] send
          | #[xref(target="DNS_Name_Service_Reply") DNS Name Service Reply packets]
          | once it has received at least one
          | #[xref(target="DNS_Query") DIM Name Service Query] packet.

        section(anchor="DNS_Registration")
          name DIM Name Service Registration

          t
            | The DIM Name Service Registration packet is a #[tt Type=1] DIM
            | Name Service request.

          t
            | This packet #[bcp14 MUST] be sent by a DIM Service provider
            | to register its services on a DIM Name Server or whenever
            | a service gets modified (or added/removed).

          figure
            name DIM Name Service Registration packet
            artwork(align='center' type='ascii-art' name='' alt='')
              .
                <![CDATA[
                 0                   1                   2                   3
                 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                Size=(108 + Num. Services * 268)               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                             Type=1                            |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                           Node Name                           +
                                               ...
                +                           (40 bytes)                          +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                           Task Name                           +
                                               ...
                +                           (36 bytes)                          +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                            Address                            |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                              PID                              |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                              Port                             |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                            Protocol                           |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                             Format                            |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                         Num. Services                         |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                            Service                            +
                                               ...
                +                          (268 bytes)                          +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                |                              ... (x Num. Services)            |
                ]]>


          t
            | The #[tt Node Name] and #[tt Task Name] fields contents are
            | described in #[xref(target="Node_Names")].

          t
            | The #[tt Address] field #[bcp14 SHOULD] contain the IPv4 address
            | where the registering service can be found, on the contrary of all
            | other fields the address is encoded in big-endian ;
            | the #[tt Node Name] field #[bcp14 MUST] be used rather than the
            | #[tt Address] to resolve a DIM Node address (thus supporting IPv6).

          t
            | The #[tt PID] field #[bcp14 SHOULD] contain the process PID, or a
            | unique identifier for this service instance.

          t
            | The #[tt Address] and #[tt PID] are set for informational purpose,
            | they #[bcp14 MAY] be used by clients to detect
            | services changes (reboot, crashes or restarts ...).

          t
            | The #[tt Protocol] field is always set to 1 in current
            | implementation.

          section
            name Format Field

            t The #[tt Format] field is encoded as follows:
            figure
              name Format field details
              artwork(align='center' type='ascii-art' name='' alt='')
                .
                  <![CDATA[
                   0                   1                   2                   3
                   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |Endian.|Float .|                   Misc Flags                  |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  ]]>

            t
              | The #[tt Endianness] part of the #[tt Format] field defines
              | how payload values are encoded, it supports two values:
            ul
              li #[strong Little Endian]: 0x1
              li #[strong Big Endian]: 0x2

            t
              | The #[tt Float Encoding] part of the #[tt Format] field defines
              | how floating point numbers are encoded, it supports the three
              | values:
            ul
              li #[strong VAX Float]: 0x1 (deprecated)
              li #[strong IEEE-754 Float]: 0x2 (default)
              li #[strong AXP Float]: 0x3 (deprecated)

            t
              | #[strong Note:] it is #[bcp14 RECOMMENDED] to use Little-Endian
              | along with IEEE-754 floats on all architectures, the legacy
              | implementation having a very limited support of any other value.

            t
              | The #[tt Misc Flags] field is meant to trigger additional format
              | related features, legacy implementation defines the following values:
            ul
              li #[strong MY_OS9]: 0x1 (deprecated)
              li #[strong IT_IS_FLOAT]: 0x10 (deprecated)

            t
              | #[strong Node:] it is #[bcp14 RECOMMENDED] to #[strong not] use
              | those flags, their meaning and support in legacy implementation
              | being hazardous.

            t
              | The #[tt Num. Services] field contains the number of
              | #[tt Service] fields following it.

          section
            name Service Field

            t The #[tt Service] Field is encoded as follows:
            figure
              name Service field details
              artwork(align='center' type='ascii-art' name='' alt='')
                .
                  <![CDATA[
                   0                   1                   2                   3
                   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                                                               |
                  +                          Service Name                         +
                                                 ...
                  +                          (132 bytes)                          +
                  |                                                               |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                   Service ID                  | Service Flags |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                                                               |
                  +                       Service Definition                      +
                                                 ...
                  +                          (132 bytes)                          +
                  |                                                               |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  ]]>

            t
              | The #[tt Service Name] field is as described in
              | #[xref(target="Service_Name")].

            t
              | The #[tt Service ID] is used by the DIM Service Provider to
              | refer to a registered service, sending updates or removal
              | notifications, it #[bcp14 MUST] be different for each service
              | being registered.

            t
              | The #[tt Service Flags] adds some extra information about the
              | service, here are the supported flags:
            table(align='center')
              name DIM Service Flags
              thead
                tr
                  th Flag
                  th Name
                  th Description
              tbody
                tr
                  td 0x10
                  td CMD
                  td This service is a Command service
                tr
                  td 0x80
                  td REMOVE
                  td Service removal request

            t
              | The #[tt Service Definition] field is as described in
              | #[xref(target="Service_Definition")].

            t
              | Command and RPC services #[bcp14 SHOULD] set the "CMD" or "RPC"
              | #[tt Service Flag] in their #[tt Service Definition] field.

            section(anchor="DNS_Service_Update")
              name Service Removal and Update

              t
                | When a service is removed or updated a DIM Name Service
                | Registration packet containing at least the removed or
                | modified service #[bcp14 MUST] be sent, unmodified
                | services #[bcp14 SHOULD] not be sent along with this packet.

              t
                | Once a service has been removed its associated #[tt Service ID]
                | and any additional information #[bcp14 MUST] be removed from
                | the DIM Name Server.

              t
                | DIM Service Provider #[bcp14 SHOULD] send an update packet
                | at least once every 60 to 90 seconds, this periodic update
                | being used as a keep-alive, this update packet #[bcp14 MAY]
                | be empty.

        section(anchor="DNS_Query")
          name DIM Name Service Query
          t
            | The DIM Name Service Query packet is a #[tt Type=2] DIM Name
            | Service Request.

          t
            | This packet is sent by a DIM Client to retrieve information about
            | a service.

          figure
            name DIM Name Service Query packet
            artwork(align='center' type='ascii-art' name='' alt='')
              .
                <![CDATA[
                 0                   1                   2                   3
                 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                            Size=144                           |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                             Type=2                            |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                          Service Name                         +
                                               ...
                +                          (132 bytes)                          +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                           Service ID                          |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                ]]>

          t
            | The #[tt Service Name] field contains the name of the service being
            | requested.

          t
            | The #[tt Service ID] is an identifier that will be used by the DIM
            | DNS Server in its reply.

        section(anchor="DNS_Name_Service_Reply")
          name DIM Name Service Reply

          t
            | The DIM Name Service Reply packet is sent by the DIM Name Server
            | in reply to a
            | #[xref(target="DNS_Query") DIM Name Service Query].

          t
            | The DIM Name Service Query is a subscription request, as long
            | as the DIM Client connection remains open, the DIM Name Server
            | #[bcp14 MUST] send DIM Name Service Reply packets whenever
            | the subscribed service description is modified, reusing the query
            | #[tt Service ID] in each notification.

          t
            | A DIM Name Service Reply packet with an empty #[tt Node Name] or
            | starting with #[tt 0xFF] (deprecated) #[bcp14 MUST] be sent by
            | the DIM Name Server to notify clients about non-existing services
            | or services being disconnected.

          t
            | DIM Name Servers #[bcp14 MUST NOT]
            | wait to send the first DIM Name Service Reply packet, even
            | when service does not exist (yet).

          figure
            name DIM Name Service Reply packet
            artwork(align='center' type='ascii-art' name='' alt='')
              .
                <![CDATA[
                 0                   1                   2                   3
                 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                            Size=236                           |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                           Service ID                          |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                       Service Definition                      +
                                               ...
                +                          (132 bytes)                          +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                           Node Name                           +
                                               ...
                +                           (40 bytes)                          +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                           Task Name                           +
                                               ...
                +                           (36 bytes)                          +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                            Address                            |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                              PID                              |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                              Port                             |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                            Protocol                           |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                             Format                            |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                ]]>

          t
            | The #[tt Service ID] field contains the identifier that was sent
            | in the DIM Name Service Query.

          t
            | The #[tt Service Definition] field is as described in
            | #[xref(target="Service_Definition")].

          t
            | All other fields have the same content than the ones provided by
            | the DIM Service Provider during its registration
            | (see #[xref(target="DNS_Registration")]).

        section(anchor="DNS_Command")
          name DIM Name Service Command packet

          t
            | The DIM Name Service Command packet is sent by the DIM Name Server
            | to inform or act on a DIM Service Provider.

          figure
            name DIM Name Service Command packet
            artwork(align='center' type='ascii-art')
              .
                <![CDATA[
                 0                   1                   2                   3
                 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                              Size                             |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |            Command            |              Info             |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                            Payload                            +
                                               ...
                +                        (Size - 8 bytes)                       +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                ]]>

          t The #[tt Command] field can be one of:
          table(align='center')
            name DIM Name Service Commands
            thead
              tr #[th Code] #[th Command]
            tbody
              tr
                td 0x00
                td #[xref(target="DNS_Command_Register") Register]
              tr
                td 0x01
                td #[xref(target="DNS_Command_Duplicate") Duplicate Service or Task Name]
              tr
                td 0x02
                td #[xref(target="DNS_Command_STOP") STOP]
              tr
                td 0x03
                td #[xref(target="DNS_Command_EXIT") EXIT]
              tr
                td 0x04
                td #[xref(target="DNS_Command_SOFT_EXIT") SOFT_EXIT]

          t The #[tt Info] field meaning depends on the command.

          section(anchor="DNS_Command_Register")
            name DNS Register Command

            t
              | The #[tt DNS Register Command] is used to request a DIM Service
              | Provider to send a complete
              | #[xref(target="DNS_Registration") DNS Registration packet].

            t This packet has no #[tt Payload].

            t
              | This packet #[bcp14 MUST] be sent by the DIM Name Server if no
              | #[xref(target="DNS_Registration") DNS Registration packets]
              | are received for more than 108 seconds (90*1.2, see
              | #[xref(target="DNS_Service_Update")] for details).

            t
              | Once this packet has been sent, if no
              | #[xref(target="DNS_Registration") DNS Registration packet]
              | is received for an additional 108 seconds, the DIM Service
              | Provider connection #[bcp14 SHOULD] be terminated by the DIM
              | Name Server.

          section(anchor="DNS_Command_Duplicate")
            name DNS Duplicate Service or Task Name Command

            t
              | The #[tt DNS Duplicate Service or Task Name Command] is used to warn
              | a DIM Service Provider that some of its services, or its Task Name
              | are already registered by another DIM Service Provider.

            t
              | The #[tt Info] field #[bcp14 MUST] be set to #[tt 0x01] to notify
              | a Task Name collision, the DIM Name Server #[bcp14 MUST] terminate
              | the connection once this packet has been sent.

            t
              | The DIM Service Provider #[bcp14 SHOULD] stop its operation
              | whenever a Duplicate Task Name notification is received, on the
              | contrary it #[bcp14 SHOULD] continue to operate on Duplicate
              | Service notification, services notified as duplicate #[bcp14 MUST NOT] be
              | registered by the DIM Name Server.

            t
              | The payload of this packet #[bcp14 MUST] match the following
              | #[xref(target="RFC5234") abnf syntax]:
            figure
              name DUP Service payload syntax
              sourcecode(type='abnf')
                | dup_service = node_info SP num_dups *(SP dup_id)
                |
                | node_info = task_name "(" node_pid ")" "@" node_name ":" node_port
                | ; task_name and node_name are described in a dedicated section
                | node_pid = 1*DIGIT
                | node_port = 1*DIGIT
                |
                | ; number of dup_id entries
                | num_dups = 1*DIGIT
                | ; duplicate service id in hexadecimal notation
                | dup_id = 8(HEXDIG)

            t
              | #[strong Note:] The #[tt Size] field is always set to 8 in legacy
              | implementation, thus DIM Service Providers #[bcp14 SHOULD] not
              | take this value in account (and rely on DNA to ensure the packet
              | is properly sized).

          section(anchor="DNS_Command_STOP")
            name DNS STOP Command

            t
              | The DIM Service Provider #[bcp14 SHOULD] stop its operation
              | whenever this command is received, being equivalent to an
              | #[xref(target="DIS_Builtin_Services") EXIT] builtin service call
              | with #[tt -1] argument.

            t
              | The DIM Name Server #[bcp14 MUST] terminate the connection once
              | this command has been sent.

            t
              | The DIM Service Provider #[bcp14 SHOULD] not try to reconnect
              | once such a command has been received.

          section(anchor="DNS_Command_EXIT")
            name DNS EXIT Command

            t
              | The #[tt DNS EXIT] command is identical to the #[tt DNS STOP]
              | command.

          section(anchor="DNS_Command_SOFT_EXIT")
            name DNS SOFT EXIT Command

            t
              | The #[tt DNS SOFT EXIT] command is similar to the #[tt DNS STOP]
              | command, the exit argument being held in #[tt Info] field.

        section
          name DIM Name Service sequence diagrams

          t
            | This section describes the nominal flow diagrams used by
            | the DIM Name Server.

          figure
            name DIM Name Service Registration
            artwork(align='center' type='ascii-art' name='' alt='')
              .
                <![CDATA[
                              DIM Name Service Registration
                +--------------------+                +---------------+
                |                    |                |               |
                |DIM Service Provider|                |DIM Name Server|
                |                    |                |  Port: 2505   |
                +---------+----------+                +-------+-------+
                          |                                   |   +-----------+
                          |                                   |   |  Example  |
                          +-----                              |   |Information|
                          |     \ DNA Header/DNA Open         |   +-----------+
                          |      -----------------------------> Node=example-server
                          |                                   | Task=1234
                          +-----                              |
                          |     \ DNA Header/DNS Registration |
                          |      -----------------------------> Node=example-server
                          |                                   | Address=192.168.0.2
                          |        +-------------------+      | Task=1234 Pid=1234
                          |        | Service "TEST/ex" |      | Protocol=1 Port=5555
                          |        |  is now known by  |      | Format=0x21
                          |        |     DIM DNS       |      |
                          |        +-------------------+      | Serv. Name="TEST/ex"
                          |                                   | Serv. ID=1
                          |                                   | Serv. Def.="I:1"
                      +---+---+                           +---+---+
                ]]>

          figure
            name DIM Name Service Query
            artwork(align='center' type='ascii-art' name='' alt='')
              .
                <![CDATA[
                            DIM Name Service Query
                +----------+                     +---------------+
                |          |                     |               |
                |DIM Client|                     |DIM Name Server|
                |          |                     |  Port: 2505   |
                +----------+                     +---------------+
                     |                                   |   +-----------+
                     |                                   |   |  Example  |
                     +-----                              |   |Information|
                     |     \ DNA Header/DNA Open         |   +-----------+
                     |      -----------------------------> Node=example-client
                     +-----                              | Task=1212
                     |     \ DNA Header/DNS Query        |
                     |      -----------------------------> Serv. Name="TEST/ex"
                     |                                   | Serv. ID=1
                     |                                   |
                     |                              -----+ Serv. ID=1
                     |        DNA Header/DNS Reply /     | Serv. Def.="I:1"
                     <-----------------------------      | Node=example-server
                     |                                   | Task=1234
                     |      +----------------------+     | Address=192.168.0.2
                     |      | DIM Client now knows |     | Pid=1234
                     |      |    where to find     |     | Protocol=1
                     |      |  service "TEST/ex"   |     | Format=0x21
                     |      +----------------------+     |
                 +---+---+                           +---+---+
                ]]>

        section(anchor="DNS_Builtin_Services")
          name DNS Built-in Services
          t
            | A DIM Name Server #[bcp14 MUST] implement a set of services.
          table(align='center')
            name DIM Name Server Built-in Services
            thead
              tr #[th Service] #[th Type] #[th Description]
            tbody
              tr #[td DIS_DNS/SERVER_LIST] #[td C]
                td Lists registered servers
              tr #[td DIS_DNS/SERVER_INFO] #[td ]
                td Deprecated server and service info
              tr #[td DIS_DNS/KILL_SERVERS] #[td I|CMD]
                td Exit or Soft-exit all connected servers
              tr #[td DIS_DNS/SERVICE_INFO] #[td C,C|RPC]
                td Retrieve service description

          section(anchor="DNS_Server_List_Service")
            name Server List Service
            t
              | The #[tt SERVER_LIST] service #[bcp14 MUST] match the following
              | #[xref(target="RFC5234") abnf syntax]:
            figure
              name Server List syntax
              sourcecode(type='abnf')
                | server_list = [server *("|" server)] "\0" [pid *("|" pid)]
                |
                | server = task_name "@" node_name
                | pid = 1*DIGIT
                | ; task_name and node_name are described in a dedicated section

            t
              | For each #[tt server] in the list its corresponding #[tt pid]
              | is listed in the following #[tt pid] list, this list #[bcp14 MUST]
              | have as many values as the #[tt server] list itself and respects
              | the same order.

            t
              | When monitored the #[tt SERVER_LIST] sends updates rather than
              | complete list upon modification, those updates #[bcp14 MUST] match the
              | following #[xref(target="RFC5234") abnf syntax]:
            figure
              name Server List updates syntax
              sourcecode(type='abnf')
                | server_list_update = ("+" / "-") server "\0" pid


          section
            name Server Info Service
            t
              | The #[tt SERVER_INFO] service informs clients about
              | #[xref(target="DIS") DIM Service Provider] registrations and
              | updates.

            t
              | This service is not really reliable, and #[bcp14 MAY] not be
              | implemented in new DIM Name Servers.

            t
              | This service is meant to be monitored, it will send
              | binary encoded events, those events being really similar to
              | #[xref(target="DNS_Registration") DNS Registration packets]:
            figure
              name Server Info event
              artwork(align='center' type='ascii-art' name='' alt='')
                .
                  <![CDATA[
                   0                   1                   2                   3
                   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                                                               |
                  +                           Node Name                           +
                                                 ...
                  +                           (40 bytes)                          +
                  |                                                               |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                                                               |
                  +                           Task Name                           +
                                                 ...
                  +                           (40 bytes)                          +
                  |                                                               |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                              PID                              |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                         Num. Services                         |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                                                               |
                  +                            Service                            +
                                                 ...
                  +                          (144 bytes)                          +
                  |                                                               |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                                                               |
                  |                              ... (x Num. Services)            |
                  ]]>

            t
              | The #[tt Node Name] and #[tt Task Name] fields contents are
              | described in #[xref(target="Node_Names")].

            t
              | The #[tt PID] field #[bcp14 SHOULD] contain the process PID, or a
              | unique identifier for this service instance.

            t
              | The #[tt Num. Services] field contains the number of
              | #[tt Service] the DIM Service Provider provides.

            t
              | Services that have been notified as duplicate #[bcp14 SHOULD]
              | not be listed, thus the #[tt Num. Services] field #[bcp14 MAY]
              | not match the number of services sent.

            t
              | #[strong Note:] events are sent only when DIM Service Providers
              | send a #[xref(target="DNS_Registration") DNS Registration packet].

            t
              | #[strong Note:] in current implementation random events are
              | sent every 5 seconds (the event is likely to be about the DNS
              | Built-in services).

            section
              name Service Field

              t The #[tt Service] Field is encoded as follows:
              figure
                name Service field details
                artwork(align='center' type='ascii-art' name='' alt='')
                  .
                    <![CDATA[
                     0                   1                   2                   3
                     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                    |                                                               |
                    +                          Service Name                         +
                                                   ...
                    +                          (132 bytes)                          +
                    |                                                               |
                    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                    |                              Type                             |
                    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                    |                            Status=1                           |
                    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                    |                          Num. Clients                         |
                    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                    ]]>

              t
                | The #[tt Service Name] field is as described in
                | #[xref(target="Service_Name")].

              t
                | The #[tt Type] field #[bcp14 MUST] be set to #[tt 1] for
                | Command services, to #[tt 0] otherwise.

              t
                | The #[tt Num. Clients] field contains the number of alive
                | clients that queried this service.

          section
            name Kill Servers Command
            t
              | The #[tt KILL_SERVERS] command will send an
              | #[xref(target="DNS_Command_EXIT") EXIT] or
              | #[xref(target="DNS_Command_SOFT_EXIT") SOFT_EXIT] to all
              | connected DIM Service Providers, excluding the DIM Name Server itself.

            t
              | When the integer parameter is omitted an #[tt EXIT] command is
              | sent, otherwise it is used as the #[tt SOFT_EXIT] parameter.

          section(anchor="DNS_Service_Info_RPC")
            name Service Info RPC
            t
              | The #[tt SERVICE_INFO] RPC is used to retrieve information
              | about services
              | (see #[xref(target="RPC_Services") DIM RPC Services] for
              | details about RPC services).

            t
              | The RPC parameter is the name of the service being requested,
              | a leading or trailing #[tt "*"] wildcard #[bcp14 MAY] also
              | be used, requesting the DNS to return services starting or ending
              | with the associated pattern.

            t
              | A single #[tt "*"] wildcard, with no additional text
              | #[bcp14 MAY] be used to request the complete service list.

            t
              | Returned information #[bcp14 MUST] match the
              | following #[xref(target="RFC5234") abnf syntax]:
            figure
              name Service Info syntax (using case-sensitive strings)
              sourcecode(type='abnf')
                | service_list = *(service_info "\n")
                |
                | service_info = service_name "|" args "|" [ "CMD" ]
                | service_info /= service_name "|" args "," args "|RPC"
                |
                | args = *(type ":" num ";") type [":" num] ["|" flag]
                | type = "I" / "C" / "L" / "S" / "F" / "D" / "X"
                | ; service_name is described in the associated section

            t
              | #[strong Note:] RPC services pairs are displayed as a single service,
              | removing the #[tt "/RpcIn"] or #[tt "/RpcOut"] suffix fromt their name.


      section(anchor="DIS")
        name DIM Service Provider (DIS)

        t
          | A DIM Service Provider, also named DIS, provides services that can
          | be subscribed by DIM Clients.

        section(anchor="DIS_Subscribe")
          name DIS Subscribe packet

          t
            | The DIM Subscribe packet is sent by a DIM Client to a
            | DIM Service Provider in order to subscribe a service or trigger
            | a command service.

          figure
            name DIM Subscribe packet
            artwork(align='center' type='ascii-art')
              .
                <![CDATA[
                 0                   1                   2                   3
                 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                              Size                             |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                          Service Name                         +
                                               ...
                +                          (132 bytes)                          +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                           Service ID                          |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |          Type         |                 Flags                 |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                            Timeout                            |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                             Format                            |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                            Payload                            +
                                               ...
                +                       (Size - 152 bytes)                      +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                ]]>

          t The #[tt Service Name] is the name of the service being requested.

          t
            | The #[tt Service ID] field is an identifier that #[bcp14 MUST] be
            | sent back by the DIM Service Provider in
            | #[xref(target="DIS_Publish") DIS Publish] replies.

          t
            | The #[tt Type] field defines the subscription type, it can be
            | one of:
          table(align='center')
            name DIM Subscription Types
            thead
              tr #[th Type] #[th Name] #[th Description]
            tbody
              tr #[td 0x01] #[td ONCE_ONLY]
                td #[xref(target="DIS_Sub_Once") Request a value once]
              tr #[td 0x02] #[td TIMED]
                td #[xref(target="DIS_Sub_Mon") Request a value periodically]
              tr #[td 0x04] #[td MONITORED]
                td #[xref(target="DIS_Sub_Mon") Request to monitor a value]
              tr #[td 0x08] #[td COMMAND]
                td #[xref(target="DIS_Command") Send a command]
              tr #[td 0x10] #[td DELETE]
                td #[xref(target="DIS_Delete") Unsubscribe]
              tr #[td 0x20] #[td MONIT_ONLY]
                td #[xref(target="DIS_Sub_Mon_Only") Special Monitor value]
              tr #[td 0x40] #[td UPDATE]
                td #[xref(target="DIS_Sub_Update") Special Monitor value]
              tr #[td 0x80] #[td TIMED_ONLY]
                td #[xref(target="DIS_Sub_Timed_Only") Special Timed value]
              tr #[td 0x100] #[td MONIT_FIRST]
                td #[xref(target="DIS_Sub_Mon_First") Special Monitor value]

          t
            | #[strong Note:] when an invalid #[tt Service Name] is provided
            | the client connection #[bcp14 MUST] be terminated, unless in
            | #[xref(target="DIS_Delete") DIS Unsubscribe] packets where it
            | #[bcp14 MAY] be ignored.

          section(anchor="DIS_Sub_Once")
            name DIS Once Only Subscription

            t The associated service value #[bcp14 MUST] be sent only once.

            t
              | The DIM Client #[bcp14 SHOULD] consider that there's a Service
              | failure if no reply is received from the server for more than
              | #[tt Timeout] seconds (if Timeout is set), this information
              | #[bcp14 MAY] also be taken in account by the server to consider
              | that it is not relevant anymore to send the information.

          section(anchor="DIS_Sub_Mon")
            name DIS Timed/Monitored Subscription

            t The #[tt TIMED] and #[tt MONITORED] types are identical.

            t
              | A first notification #[bcp14 MUST] be sent to the subscribing
              | DIM Client with the current service value, or an empty payload
              | if the value is not set.

            t
              | When #[tt Timeout] value is set (not zero) the service value
              | #[bcp14 MUST] be sent every #[tt Timeout] seconds.

            t
              | The DIM Client #[bcp14 SHOULD] consider that there's a Service
              | failure and clear its recorded value if #[tt Timeout] is set
              | and no values are received for more than #[tt 1.5*Timeout].

            t
              | Services value changes #[bcp14 SHOULD] be notified on
              | modification, depending on the service implementation.

          section(anchor="DIS_Command")
            name DIS Command

            t
              | This #[tt DIM Subscribe] packet is used to trigger a command
              | type service on the #[tt DIM Service Provider].

            t The #[tt Timeout] and #[tt Service ID] fields are ignored.

            t
              | The #[tt Payload] field #[bcp14 MUST] contain the Command
              | arguments as described in the
              | #[xref(target="Service_Definition") Service Definition].

            t
              | The DIM Service Provider #[bcp14 MUST NOT] send a reply when a
              | command is received.

          section(anchor="DIS_Sub_Mon_Only")
            name DIS Monitored Only Subscription

            t
              | The #[tt MONIT_ONLY] type is similar to
              | #[xref(target="DIS_Sub_Mon") MONITORED], unless that the current
              | value #[bcp14 MUST NOT] be sent and that #[tt Timeout] value
              | is ignored.

            t
              | The first notification #[bcp14 SHOULD] be sent when the service
              | notifies a value modification.

          section(anchor="DIS_Sub_Update")
            name DIS Update Subscription

            t
              | The #[tt UPDATE] type is similar to
              | #[xref(target="DIS_Sub_Mon_Only") MONIT_ONLY], unless that
              | #[tt Timeout] value is taken in account.

          section(anchor="DIS_Sub_Timed_Only")
            name DIS Timed Only Subscription

            t
              | The #[tt TIMED_ONLY] type is similar to
              | #[xref(target="DIS_Sub_Mon") TIMED], unless that value
              | modification notifications are not taken in account.

          section(anchor="DIS_Sub_Mon_First")
            name DIS Monitored First Subscription

            t
              | The #[tt MONIT_FIRST] type is identical to
              | #[xref(target="DIS_Sub_Mon") MONITORED] type with #[tt Timeout]
              | set to zero.

          section(anchor="DIS_Delete")
            name DIS Unsubscribe

            t
              | This #[tt DIM Service Subscribe] packet is used to unsubscribe
              | a service.

            t The #[tt Timeout] field is ignored.

            t
              | Unregistering an unknown #[tt Service ID] #[bcp14 SHOULD] have
              | no effect on the DIM Service Provider.

        section(anchor="DIS_Publish")
          name DIS Publish packet

          t
            | The DIM Publish packet is sent by the DIM Service Provider
            | to publish values and updates on subscribed services.

          figure
            name DIM Publish packet
            artwork(align='center' type='ascii-art')
              .
                <![CDATA[
                 0                   1                   2                   3
                 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                              Size                             |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                           Service ID                          |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                |                                                               |
                +                            Payload                            +
                                               ...
                +                        (Size - 8 bytes)                       +
                |                                                               |
                +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                ]]>

          t
            | The #[tt Service ID] field contains the #[tt Service ID] value
            | that the DIM Client used when registering to this service.

          t
            | The #[tt Payload] content #[bcp14 MUST] contain the service
            | value encoded as described in the
            | #[xref(target="Service_Definition") Service Definition] related
            | to this service, it #[bcp14 MAY] be empty if the value is
            | not available.

          section(anchor="DIS_Publish_Timed")
            name DIS Timestamped Publish

            t
              | DIM Publish packets #[bcp14 MUST] be sent with extra timestamp
              | and quality information to clients that made a
              | #[xref(target="DIS_Subscribe") Subscription] using the
              | #[tt STAMPED] flag.

            figure
              name DIM Timestamped Publish packet
              artwork(align='center' type='ascii-art')
                .
                  <![CDATA[
                   0                   1                   2                   3
                   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                              Size                             |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                           Service ID                          |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |         Timestamp (ms)        |          Magic=0xc0de         |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                         Timestamp (s)                         |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                            Quality                            |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                        Magic=0xc0dec0de                       |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                            Reserved                           |
                  |                                                               |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  |                       (Size - 32 bytes)                       |
                  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                  ]]>

            t
              | One of the two #[tt Magic] fields #[bcp14 MUST] be set with its
              | magic value, both #[bcp14 SHOULD] be set.

            t
              | The #[tt Timestamp (s)] field contains a UNIX timestamp,
              | the #[tt Timestamp (ms)] brings millisecond precision.

            t
              | The #[tt Quality] field is an integer that represents the
              | service value quality, its content is left unspecified and
              | depends on the DIM Service Provider implementation.

        section(anchor="RPC_Services")
          name DIM RPC Services

          t DIM RPC Services are built on a pair of services.

          t The first service name #[bcp14 MUST] end with #[tt "/RpcOut"].

          t
            | The second service name #[bcp14 MUST] end with #[tt "/RpcIn"],
            | this service #[bcp14 MUST] be a #[tt COMMAND] service.

          t
            | The part prior to #[tt "/RpcOut"] or #[tt "/RpcIn"] #[bcp14 MUST]
            | be identical for both services.

          t
            | When a command is sent on #[tt "/RpcIn"] its reply is sent as a
            | value change notification on the #[tt "/RpcOut"] service. The
            | notification #[bcp14 MUST] be sent only to the DIM Client that
            | made the request.

        section(anchor="DIS_Builtin_Services")
          name DIS Built-in Services
          t
            | A DIM Service Provider #[bcp14 MUST] implement a set of services,
            | all those services #[bcp14 MUST] be prefixed with the DIM Service
            | Provider #[tt Task Name] followed by a slash ('/').
          table(align='center')
            name DIM Service Provider Built-in Services
            thead
              tr #[th Service] #[th Type] #[th Description]
            tbody
              tr #[td VERSION_NUMBER] #[td L:1]
                td DIM version number
              tr #[td SERVICE_LIST] #[td C]
                td Lists provided services
              tr #[td CLIENT_LIST] #[td C]
                td Lists connected clients
              tr #[td SET_EXIT_HANDLER] #[td L:1|CMD]
                td Automatically exit on disconnect
              tr #[td EXIT] #[td L:1|CMD]
                td Exit the server

          section
            name Version Number Service
            t
              | The #[tt VERSION_NUMBER] service #[bcp14 MUST] return the DIM
              | library version number, latest legacy implementation version
              | number being #[tt 2023].

          section
            name Service List Service
            t
              | The #[tt SERVICE_LIST] service is similar to the
              | #[xref(target="DNS_Service_Info_RPC") DNS Service Info RPC],
              | it #[bcp14 MUST] match the following
              | #[xref(target="RFC5234") abnf syntax]:
            figure
              name Service List syntax (using case-sensitive strings)
              sourcecode(type='abnf')
                | service_list = *(service_info "\n")
                |
                | service_info = service_name "|" args "|" [ "CMD" ]
                | service_info /= service_name "|" args "," args "|RPC"
                |
                | args = *(type ":" num ";") type [":" num] ["|" flag]
                | type = "I" / "C" / "L" / "S" / "F" / "D" / "X"
                | ; service_name is described in the associated section

            t
              | #[strong Note:] RPC services pairs are displayed as a single service,
              | removing the #[tt "/RpcIn"] or #[tt "/RpcOut"] suffix fromt their name.

            t
              | When monitored the #[tt SERVICE_LIST] sends updates rather than
              | complete list upon modification, those updates #[bcp14 MUST] match the
              | following #[xref(target="RFC5234") abnf syntax]:
            figure
              name Client List updates syntax
              sourcecode(type='abnf')
                | prefix = "+" / "-"
                | service_list_update = *([ prefix ] service_name)

            t
              | On updates the #[tt prefix] is #[bcp14 OPTIONAL], but
              | it is #[bcp14 RECOMMENDED] for new implementations to set it
              | on every service being updated, updates with
              | no prefixes #[bcp14 SHOULD] be considered as with the last prefix
              | received in the given update message (defaulting to "+").

            t
              | #[strong Note:] Legacy implementation sends a single "+" on the
              | first service added, and "-" on each service removed for a
              | given update.

          section
            name Client List Service
            t
              | The #[tt CLIENT_LIST] service is similar to the
              | #[xref(target="DNS_Server_List_Service") Server List Service],
              | it #[bcp14 MUST] match the following
              | #[xref(target="RFC5234") abnf syntax]:
            figure
              name Client List syntax
              sourcecode(type='abnf')
                | client_list = [client *("|" client)]
                |
                | client = task_name "@" node_name
                | ; task_name and node_name are described in a dedicated section

            t
              | When monitored the #[tt CLIENT_LIST] sends updates rather than
              | complete list upon modification, those updates #[bcp14 MUST] match the
              | following #[xref(target="RFC5234") abnf syntax]:
            figure
              name Client List updates syntax
              sourcecode(type='abnf')
                | client_list_update = ("+" / "-") client

          section
            name Exit and Exit Handlers Services
            t
              | The #[tt SET_EXIT_HANDLER] command adds a listening hook to
              | current connection, upon disconnection an #[tt exit_handler]
              | function #[bcp14 MUST] be called on the DIM Service Provider.
              | the integer value associated with this command #[bcp14 MUST] be
              | provided to the associated #[tt exit_handler].

            t
              | The #[tt EXIT] command is similar to the #[tt SET_EXIT_HANDLER],
              | but the #[tt exit_handler] function #[bcp14 MUST] be called
              | right-away.

            t
              | The implementation of the #[tt exit_handler] is left unspecified,
              | the DIM Service Provider #[bcp14 MAY] have a default
              | implementation for this function.

      section
        name Naming Conventions and Syntax

        section(anchor="Node_Names")
          name Node and Task names

          t
            | #[tt Node] names #[bcp14 MUST] contain the hostname or IP address
            | (in dot-decimal notation) of the machine hosting the associated DIM
            | Node, it #[bcp14 MUST] match the following
            | #[xref(target="RFC5234") abnf syntax]:
          figure
            name Node Name syntax
            sourcecode(type='abnf')
              | node_name = (ALPHA / DIGIT) [ *38(ALPHA / DIGIT / "-") (ALPHA / DIGIT)]
              | node_name =/ %d0-255 3("." %d0-255)

          t
            | #[strong Note:] Node names being limited to 40 bytes, long hostnames
            | as described in #[xref(target="RFC1123")] are not supported.

          t
            | #[tt Task] names #[bcp14 SHOULD] be different for each DIM Node
            | and #[bcp14 MUST] be different for each DIM Service Provider.

          t
            | This name is used to implement DIS Built-in Services
            | (see #[xref(target="DIS_Builtin_Services")]), it #[bcp14 MUST] match
            | the following #[xref(target="RFC5234") abnf syntax]:
          figure
            name Task Name syntax
            sourcecode(type='abnf')
              | task_name = (ALPHA / DIGIT) [ *34(body) (ALPHA / DIGIT)]
              |
              | body = (ALPHA / DIGIT / "-" / "+" / "_" / "." / ":")
              | ; Note: same limitations than Service Names

          t
            | #[strong Note:] legacy implementation does not validate Task or
            | Node names.

        section(anchor="Service_Name")
          name Service Name

          t
            | The #[tt Service Name] identifies a service, it #[bcp14 MUST] be
            | unique for a given DIM DNS Server.
          t
            | Services names #[bcp14 SHOULD] be encoded as a list of slash ('/')
            | separated words, starting with the general service
            | name and going to more precise object/parameter/properties.
            | It is #[bcp14 RECOMMENDED] to use the following
            | #[xref(target="RFC5234") abnf syntax]:
          figure
            name Service Name syntax
            sourcecode(type='abnf')
              | service_name = part *( "/" part )
              |
              | part = (ALPHA / DIGIT) *body
              | body = (ALPHA / DIGIT / "-" / "+" / "_" / "." / ":")
              |
              | ; some information on why such limitations:
              | ; "/" is used as a separator in services
              | ; "|" is used in client list
              | ; "@" is used in client list
              | ; "-" is used as first char in client list updates
              | ; "+" is used as first char in client list updates
              | ; "\n" is used in service list
              | ; '(' ')' are used in DUP commands

        section(anchor="Service_Definition")
          name Service Definition
          t
            | The data content that each service provides is described using
            | a #[tt Service Definition].

          t
            | It #[bcp14 MUST] match the following
            | #[xref(target="RFC5234") abnf syntax]:
          figure
            name
              | abnf representation of the Service Definition field
              | (using case-sensitive strings)
            sourcecode(type='abnf')
              | service_definition = *(type ":" num ";") type [":" num] ["|" flag]
              |
              | type = "I" / "C" / "L" / "S" / "F" / "D" / "X"
              | num = 1*DIGIT
              | flag = "CMD" / "RPC"

          t The #[tt type] being one of:
          table(align='center')
            name Service Definition types
            thead
              tr
                th Type
                th Description
                th Size (bytes)
            tbody
              tr #[td I] #[td 32 bits signed integer (int32_t)] #[td 4]
              tr #[td C] #[td character (char)] #[td 1]
              tr #[td L] #[td 32 bits signed integer (deprecated)] #[td 4]
              tr #[td X] #[td 64 bits signed integer (int64_t)] #[td 8]
              tr #[td S] #[td 16 bits signed integer (int16_t)] #[td 2]
              tr #[td F] #[td 32 bits floating point number (float)] #[td 4]
              tr #[td D] #[td 64 bits floating point number (double)] #[td 8]

          t The optional #[tt flag] being one of:
          ul
            li #[strong CMD]: The definition describes a command service where clients can send values.
            li
              | #[strong RPC]: The definition describes a Remote Procedure Call service
              | (not used in #[xref(target="DNS_Registration") DNS Registration]
              | and #[xref(target="DNS_Query") DNS Query] packets, the service pair
              | being registered as two separate services).

    section
      name Contributors
      // Optional section to mention contributors

  back

    references
      name References
      references
        name Normative References
        | &rfc2119;
        | &rfc5234;
        | &rfc1123;

      references
        name Informative References

      references
        name URL References

        reference(anchor='DIM_WEBSITE' target='http://dim.web.cern.ch/')
          front
            title The DIM protocol legacy website
            author
              organization CERN
            date(year='19')

    section
      name Change Log
      ol
        li First version

    section
      name Open Issues
      ul
        li
          | CMD and RPC flags are optional in service description, thus there's
          | no way for a client to guess that a service is a Command or RPC
          | service, unless using additional built-in services requests.
        li
          | Subscription types are a bit messy, a simple flag with
          | initial, timed, on_update, cmd and no flags for delete would be
          | better.
        li
          | Timeout field is in seconds, should be in millies with a min value.
        li
          | Using a standard format (little-endian), always adding a timestamp
          | would ease server implementation (sending the same payload to all
          | clients).
        li
          | DIM Service Provider should reply to DNS requests for their own services.
